if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

if select(2, UnitClass("player")) ~= "DRUID" then
	return
end

local VERSION = tonumber(("$Revision: 39962 $"):match("%d+"))

local PitBull = PitBull
local PitBull_DruidManaBar = PitBull:NewModule("DruidManaBar", "AceEvent-2.0", "AceConsole-2.0")
local self = PitBull_DruidManaBar
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-06-14 21:09:38 -0400 (Thu, 14 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = "Show a mana bar for your Druid when in Cat or Bear form."

local L = PitBull:L("PitBull-DruidManaBar")

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

local UnitDruidMana = UnitDruidMana
local UnitDruidManaMax = UnitDruidManaMax
local UnitPowerType = UnitPowerType
local DruidManaBarColor = DruidManaBarColor

PitBull_DruidManaBar:RegisterPitBullModuleDependencies("PowerBar")
PitBull_DruidManaBar:RegisterPitBullChildFrames('druidManaBar', 'druidManaText')

local unitsShown = {}

local Gratuity

function PitBull_DruidManaBar:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("DruidManaBar")
	PitBull:RegisterDefaults("DruidManaBar", "profile", {
		deficit = false,
		reverse = false,
		hidden = false,
		textStyle = "Absolute",
	})
end

local regenMana, maxMana, currMana, currInt, fiveSecondRule

local textStyles = {
	["Absolute"] = function()
		if currMana == maxMana then
			return ""
		end
		return currMana .. "/" .. maxMana
	end,
	["Percentage"] = function()
		if currMana == maxMana then
			return ""
		end
		return ("%.0f%%"):format(currMana / maxMana * 100)
	end,
	["Absolute and Percentage"] = function()
		if currMana == maxMana then
			return ""
		end
		return ("%d/%d || %.0f%%"):format(currMana, maxMana, currMana / maxMana * 100)
	end,
	["Hide"] = function()
		return "" 
	end,
}

function PitBull_DruidManaBar:OnEnable(first)
	if not AceLibrary:HasInstance("Gratuity-2.0") then
		error("PitBull_DruidManaBar requires the library Gratuity-2.0 to be available.")
	end
	Gratuity = AceLibrary("Gratuity-2.0")
	self:RegisterEvent("UNIT_MANA")
	self:RegisterEvent("UNIT_MAXMANA")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED", "UNIT_MAXMANA")
	self:RegisterEvent("UNIT_DISPLAYPOWER")
	self:RegisterEvent("LEARNED_SPELL_IN_TAB")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:LEARNED_SPELL_IN_TAB()
	
	if UnitPowerType("player") == 0 then
		maxMana = UnitManaMax("player")
		currMana = UnitMana("player")
		_, currInt  = UnitStat("player", 4)
	else
		currMana = 0
		maxMana = 100
		currInt = 0
	end
end

function PitBull_DruidManaBar:UNIT_MANA(arg1)
	if arg1 ~= "player" then
		return
	end
	
	if UnitPowerType("player") == 0 then
		self:CancelAllScheduledEvents()
		currMana = UnitMana("player")
		maxMana = UnitManaMax("player")
		self:Update()
	elseif currMana then
		if regenMana and not self:IsEventScheduled("PitBull_DruidManaBar-UpdateMana") then
			--Update mana every 2 seconds
			self:UpdateMana()
			self:ScheduleRepeatingEvent("PitBull_DruidManaBar-UpdateMana", self.UpdateMana, 2, self)
		end
		--if mana hasn't been updated for 7 seconds, set current mana to the max mana
		self:ScheduleEvent("PitBull_DruidManaBar-SetMax", self.SetMax, 7, self)
	end
end

function PitBull_DruidManaBar:UNIT_MAXMANA(arg1)
	if arg1 ~= "player" then 
		return
	end
	
	local _, int  = UnitStat("player", 4)
	if UnitPowerType("player") == 0 then
		maxMana = UnitManaMax("player")
		currMana = UnitMana("player")
		currInt = int
	elseif currMana then
		if currInt ~= int then
			maxMana = maxMana + ((int - currInt) * 15)
			currInt = int
			if currMana > maxMana then
				currMana = maxMana
			end
		end
	end
end

local getShapeshiftCost, getNaturesGraspCost

local function killFSR()
	fiveSecondRule = false
end

function PitBull_DruidManaBar:UNIT_DISPLAYPOWER(arg1)
	if arg1 ~= "player" then
		return
	end
	
	if UnitPowerType("player") == 0 then
		regenMana = false
		self:CancelAllScheduledEvents()
		currMana = UnitMana("player")
		maxMana = UnitManaMax("player")
		local _
		_, currInt  = UnitStat("player", 4)
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if frame.druidManaBar then
				self:OnClearUnitFrame("player", frame)
				PitBull:UpdateLayout(frame)
			end
		end
	elseif currMana then
		regenMana = true
		fiveSecondRule = true
		self:ScheduleEvent("PitBull_DruidManaBar-FSR", killFSR, 5)
		currMana = currMana - getShapeshiftCost()
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if not frame.druidManaBar then
				self:OnPopulateUnitFrame("player", frame)
				if frame.druidManaBar then
					PitBull:UpdateLayout(frame)
				end
			end
		end
	end
	
	self:Update()
end

local ngID, ngName, bearID
function getShapeshiftCost()
	Gratuity:SetSpell(bearID, BOOKTYPE_SPELL)
	local line = Gratuity:GetLine(2)
	if line then
		line = tonumber(line:match("(%d+)"))
	end
	return line or 0
end

function getNaturesGraspCost(rank)
	for i = ngID, ngID + 7 do
		local _, r = GetSpellName(i, BOOKTYPE_SPELL)
		if r == rank then
			Gratuity:SetSpell(i, BOOKTYPE_SPELL)
			local line = Gratuity:GetLine(2)
			if line then
				line = tonumber(line:match("(%d+)"))
			end
			return line or 0
		end
	end
	return 0
end

--finds the spell ID's of Nature's Grasp and Bear Form
function PitBull_DruidManaBar:LEARNED_SPELL_IN_TAB()
    for i = 1, GetNumSpellTabs() do
        local _, texture, offset, numSpells = GetSpellTabInfo(i)
        if texture:find("Spell_Nature_StarFall") then
        	for j = offset + 1, offset + numSpells do
        		if GetSpellTexture(j, BOOKTYPE_SPELL):find("Spell_Nature_NaturesWrath") then
        			ngID = j
        			ngName = GetSpellName(j, BOOKTYPE_SPELL)
        			break
        		end
        	end
        elseif texture:find("Ability_Racial_BearForm") then
        	for j = offset + 1, offset + numSpells do
        		if GetSpellTexture(j, BOOKTYPE_SPELL):find("Ability_Racial_BearForm") then
        			bearID = j
        			break
        		end
        	end
        end
    end
end

--Nature's Grasp
function PitBull_DruidManaBar:UNIT_SPELLCAST_SUCCEEDED(arg1, arg2, arg3)
	if arg1 == "player" and UnitPowerType("player") ~= 0 and arg2 == ngName then
		fiveSecondRule = true
		self:ScheduleEvent("PitBull_DruidManaBar-FSR", killFSR, 5)
		currMana = currMana - getNaturesGraspCost()
	end
end

local math_floor = math.floor
function PitBull_DruidManaBar:UpdateMana()
	local regen, castingRegen = GetManaRegen()
	if fiveSecondRule then
		currMana = currMana + math_floor(castingRegen*2 + 0.5)
	else
		currMana = currMana + math_floor(regen*2 + 0.5)
	end

	if currMana > maxMana then
		currMana = maxMana
		self:CancelAllScheduledEvents()
	end

	self:Update()
end

function PitBull_DruidManaBar:SetMax()
	currMana = maxMana
	self:CancelScheduledEvent("PitBull_DruidManaBar-UpdateMana")
	
	self:Update()
end

function PitBull_DruidManaBar:UpdateColor(frame)
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			self:UpdateColor(frame)
		end
		return
	end
	
	local r,g,b = unpack(PitBull.colorConstants.mana)
	
	if self.db.profile.reverse then
		frame.druidManaBar:SetStatusBarColor((r+0.2)/3, (g+0.2)/3, (b+0.2)/3, 1)
		frame.druidManaBar.bg:SetVertexColor(r, g, b, 1)
	else
		frame.druidManaBar:SetStatusBarColor(r, g, b, 1)
		frame.druidManaBar.bg:SetVertexColor((r+0.2)/3, (g+0.2)/3, (b+0.2)/3, 1)
	end
end

function PitBull_DruidManaBar:Update(frame)
	if not frame then
		for frame in PitBull:IterateUnitFramesForUnit("player") do
			if frame.druidManaBar then
				self:Update(frame)
			end
		end
		return
	end
	
	local db = self.db.profile
	
	if currMana and maxMana then
		local perc = currMana / maxMana
		if db.deficit ~= db.reverse then
			perc = 1 - perc
		end
		frame.druidManaBar:SetValue(perc)
		if currMana and maxMana then
			frame.druidManaText:SetText(textStyles[self.db.profile.textStyle]())
		end
	end
end

function PitBull_DruidManaBar:OnUpdateFrame(unit, frame)
	if frame.druidManaBar then
		self:Update(frame)
		self:UpdateColor(frame)
	end
end

function PitBull_DruidManaBar:OnPopulateUnitFrame(unit, frame)
	if unit ~= "player" or frame.druidManaBar or PitBull_DruidManaBar.db.profile.hidden or UnitPowerType("player") == 0 then
		return
	end
	local druidManaBar = newFrame("StatusBar", frame)
	frame.druidManaBar = druidManaBar
	druidManaBar:SetMinMaxValues(0, 1)
	druidManaBar:SetValue(1)
	druidManaBar:SetStatusBarTexture(PitBull:GetStatusBarTexture())
	druidManaBar:SetStatusBarColor(0, 0, 1, 1)

	local druidManaBarBG = newFrame("Texture", druidManaBar, "BACKGROUND")
	frame.druidManaBar.bg = druidManaBarBG
	druidManaBarBG:SetTexture(PitBull:GetStatusBarTexture())
	druidManaBarBG:SetVertexColor(0, 0, 0.5, 1)
	druidManaBarBG:ClearAllPoints()
	druidManaBarBG:SetAllPoints(druidManaBar)
	
	local druidManaText = newFrame("FontString", druidManaBar, "OVERLAY")
	frame.druidManaText = druidManaText
	druidManaText:SetFont(PitBull:GetFont())
	druidManaText:SetShadowColor(0, 0, 0, 1)
	druidManaText:SetShadowOffset(0.8, -0.8)
	druidManaText:SetNonSpaceWrap(false)
	if currMana and maxMana then
		druidManaText:SetText(textStyles[self.db.profile.textStyle]())
	end
	
	self:UpdateColor(frame)
end

function PitBull_DruidManaBar:OnClearUnitFrame(unit, frame)
	if frame.druidManaBar then
		frame.druidManaText = delFrame(frame.druidManaText)
		frame.druidManaBar.bg = delFrame(frame.druidManaBar.bg)
		frame.druidManaBar = delFrame(frame.druidManaBar)
	end
end

function PitBull_DruidManaBar:OnUpdateStatusBarTexture(texture)
	for _,frame in PitBull:IterateUnitFrames() do
		if frame.druidManaBar then
			frame.druidManaBar:SetStatusBarTexture(texture)
			frame.druidManaBar.bg:SetTexture(texture)
		end
	end
end

function PitBull_DruidManaBar:OnUnknownLayout(unit, frame, name)
	if name == "druidManaBar" then
		frame.druidManaBar:SetPoint("TOPLEFT", frame, "BOTTOMLEFT", 0, 0)
		frame.druidManaBar:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", 0, 0)
		frame.druidManaBar:SetHeight(15)
	elseif name == "druidManaText" then
		frame.druidManaText:SetPoint("RIGHT", frame.druidManaBar, "RIGHT", -3, 0)
	end
end

function PitBull_DruidManaBar:OnUpdateLayout(unit, frame)
	local old = not unitsShown[frame]
	local now = not frame.druidManaBar or not frame.druidManaBar:IsShown()
	if old == now then
		return
	end
	unitsShown[frame] = not now
	if not now then
		self:OnUpdateFrame(unit, frame)
	end
end

local function getDeficit()
	return PitBull_DruidManaBar.db.profile.deficit
end
local function setDeficit(value)
	PitBull_DruidManaBar.db.profile.deficit = value

	for frame in PitBull:IterateUnitFramesForUnit("player") do
		if frame.druidManaBar then
			PitBull_DruidManaBar:Update(frame)
		end
	end
end
local function getReverse()
	return PitBull_DruidManaBar.db.profile.reverse
end
local function setReverse(value)
	PitBull_DruidManaBar.db.profile.reverse = value

	for frame in PitBull:IterateUnitFramesForUnit("player") do
		if frame.druidManaBar then
			PitBull_DruidManaBar:Update(frame)
			PitBull_DruidManaBar:UpdateColor(frame)
		end
	end
end
local function getHide()
	return PitBull_DruidManaBar.db.profile.hidden
end
local function getEnabled()
	return not PitBull_DruidManaBar.db.profile.hidden
end
local function setEnabled(value)
	value = not value
	PitBull_DruidManaBar.db.profile.hidden = value
	
	for frame in PitBull:IterateUnitFramesForUnit("player") do
		if value then
			self:OnClearUnitFrame("player", frame)
		else
			self:OnPopulateUnitFrame("player", frame)
			self:OnUpdateFrame("player", frame)
		end
		PitBull:UpdateLayout(frame)
	end
end
PitBull_DruidManaBar:RegisterPitBullOptionsMethod(function(group)
	if group == "player" then
		local textStyleValidate = {}
		for k in pairs(textStyles) do
			textStyleValidate[k] = L[k]
		end
		return {
			name = L["Druid mana bar"],
			desc = L["Druid mana display settings for this unit type."],
			type = 'group',
			args = {
				deficit = {
					type = 'toggle',
					name = L["Show as deficit"],
					desc = L["Show druid's mana deficit, filling the bar when you use up your druidMana."],
					get = getDeficit,
					set = setDeficit,
					disabled = getHide,
				},
				reverse = {
					type = 'toggle',
					name = L["Reverse"],
					desc = L["Reverses the direction of the druid mana bar, filling it from right to left."],
					get = getReverse,
					set = setReverse,
					disabled = getHide,
				},
				hide = {
					type = 'toggle',
					name = L["Enable"],
					desc = L["Enables the druid mana bar."],
					get = getEnabled,
					set = setEnabled,
					order = 1,
				},
				textStyle = {
					type = 'text',
					name = L["Text style"],
					desc = L["Choose what kind of text to show on the druid bar"],
					get = function()
						return self.db.profile.textStyle
					end,
					set = function(value)
						self.db.profile.textStyle = value
						
						for frame in PitBull:IterateUnitFramesForUnit("player") do
							if frame.druidManaBar then
								self:Update(frame)
							end
						end
					end,
					validate = textStyleValidate,
					disabled = getHide,
				}
			}
		}
	end
end)
